package com.tashow.cloud.product.service.impl;

import com.tashow.cloud.product.dto.ProdTagsDO;
import com.tashow.cloud.product.mapper.ProdTagsMapper;
import com.tashow.cloud.product.service.ProdTagsService;
import com.tashow.cloud.product.vo.prodtags.ProdTagsPageReqVO;
import com.tashow.cloud.product.vo.prodtags.ProdTagsSaveReqVO;
import com.tashow.cloud.productapi.enums.ErrorCodeConstants;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;
import java.util.*;
import com.tashow.cloud.common.pojo.PageResult;
import com.tashow.cloud.common.pojo.PageParam;
import com.tashow.cloud.common.util.object.BeanUtils;
import static com.tashow.cloud.common.exception.util.ServiceExceptionUtil.exception;

/**
 * 商品和标签管理 Service 实现类
 *
 * @author 芋道源码
 */
@Service
@Validated
public class ProdTagsServiceImpl implements ProdTagsService {

    @Resource
    private ProdTagsMapper prodTagsMapper;

    @Override
    public Long createProdTags(ProdTagsSaveReqVO createReqVO) {
        // 插入
        ProdTagsDO prodTags = BeanUtils.toBean(createReqVO, ProdTagsDO.class);
        prodTagsMapper.insert(prodTags);
        // 返回
        return prodTags.getProductId();
    }

    @Override
    public void updateProdTags(ProdTagsSaveReqVO updateReqVO) {
        // 校验存在
        validateProdTagsExists(updateReqVO.getProductId());
        // 更新
        ProdTagsDO updateObj = BeanUtils.toBean(updateReqVO, ProdTagsDO.class);
        prodTagsMapper.updateById(updateObj);
    }

    @Override
    public void deleteProdTags(Long id) {
        // 校验存在
        validateProdTagsExists(id);
        // 删除
        prodTagsMapper.deleteById(id);
    }

    private void validateProdTagsExists(Long id) {
        if (prodTagsMapper.selectById(id) == null) {
            throw exception(ErrorCodeConstants.PROD_TAGS_NOT_EXISTS);
        }
    }

    @Override
    public ProdTagsDO getProdTags(Long id) {
        return prodTagsMapper.selectById(id);
    }

    @Override
    public PageResult<ProdTagsDO> getProdTagsPage(ProdTagsPageReqVO pageReqVO) {
        return null;
    }

}